#include <3ds.h>
#include <stdio.h>
FS_Archive sdmcArchive;

void openSDArchive()        //the basic method of mounting unmounting sd was copied from smea's hbmenu so greets to him for this
{
	sdmcArchive=(FS_Archive){0x00000009, (FS_Path){PATH_EMPTY, 1, (u8*)""}};
	FSUSER_OpenArchive(&sdmcArchive);
}

void closeSDArchive()
{
	FSUSER_CloseArchive(&sdmcArchive);
}

void gspWait(int vs){
	while(vs--)gspWaitForVBlank();
}

int main(int argc, char **argv) {
    gfxInitDefault();
    consoleInit(GFX_TOP, NULL);
	
	bool initial;
	FSUSER_IsSdmcDetected(&initial);
	
	int count=1;
	bool sdmc=initial;   //inserted is true, removed is false  (or 1/0 respectively)
	bool old_status=initial;

	openSDArchive();
	closeSDArchive();
	
    printf("SDmounty by zoogie\n\n");
    printf("SD unmounted!\nYou may remove the SD card now.\n");
	if(initial)printf("(SD is currently inserted)\n\n");
	else       printf("(SD is currently removed, this shouldn't happen!)\n\n"); //because emunand would freeze if SD was removed prior
    
    while(aptMainLoop()) {
       
        hidScanInput();
		old_status=sdmc;
        if(count % 60 == 0)FSUSER_IsSdmcDetected(&sdmc);
		
        if(hidKeysDown() & KEY_START){
            break;
		}
		
		if(sdmc != old_status){
			if(sdmc==true){
				printf("SD inserted, remounting...                  \n");
				closeSDArchive();
				openSDArchive();
				printf("Remounted SD card!                          \n");
				printf("Exiting back to home menu!                  \n");
				gspWait(60);
				break;
			}
			if(sdmc==false){
				printf("Removed SD card!                             \r");
			}
		}
		
		if((hidKeysDown() & KEY_START) && (hidKeysDown() & KEY_UP) ){
            break; //emergency bail
		}
		
        count++;
		
        gfxFlushBuffers();
        gfxSwapBuffers();
		gspWaitForVBlank();
    }
    closeSDArchive();
    gfxExit();
    return 0;
}